'use strict';

angular.module('adf.widget.electre.lavoisier')
    .controller('lavoisierHtmlCtrl',
        [
            "$scope", "config", "baseController",
            function ($scope, config, baseController) {
                $scope.valid = false;

                if (config.view) {
                    config.rendering = 'html';
                    $scope.dom = {
                        config : baseController.getUrlObject(config)
                    };

                    $scope.valid = true;
                }
            }
        ]
    ).directive(
         'lavoisierHtmlContent',
         [
             "lavoisierHttpRequestService", "parserService", "domService",
             function (lavoisierHttpRequestService, parserService, domService) {
                 var templateUrl;

                 function addDom (scope, element, attrs) {
                     if (element.children().length > 0) element.empty();

                     lavoisierHttpRequestService.getResult_2({ url : scope.control.config.url, params : scope.control.config.params })
                     .then(
                         function (value) {
                             var html = parserService.htmlDomFromString(value);
                             if (element.children().length > 0)element.empty();

                             var container = html.getElementsByTagName("X:HTML")[0].lastChild;
                             container.className = "";

                             element.append(container);
                         },
                         function () {
                             var errorRequestP = domService.createElement("p").setAttribute('class', "alert alert-warning").getDom();
                             errorRequestP.innerHTML = "An error has occurred during the request. Please verify you have entered valid info.";
                             element.append(errorRequestP);
                         }
                     );
                 }

                 return {
                     scope : {
                         control : '='
                     },
                     link : function (scope, element, attrs) {
                         addDom(scope, element, attrs);
                     }
                 };
             }
         ]
    );